express = require 'express'
http = require 'http'
useragent = require 'express-useragent'

app = express()
server = http.createServer app
io = (require 'socket.io').listen server

app.use express.static 'static'
app.use express.bodyParser()
app.use express.cookieParser()
app.use useragent.express()


app.get '/', (req, res) ->
  if req.useragent.isMobile
    res.sendfile __dirname + '/static/mobile.html'
  else
    res.sendfile __dirname + '/static/pc.html'


app.get '/ua', (req, res) ->
  res.send req.useragent


# io.configure ->
#   io.set 'log level', 1

sockets = {}

io.sockets.on 'connection', (socket) ->
  socket.on 'pc', ->
    secret = Math.floor(Math.random() * 9000) + 1000
    socket.set 'secret', secret, ->
      sockets[secret] = socket
      console.log 'connection', secret
      socket.emit 'secret', secret

      socket.on 'disconnect', ->
        console.log 'disconnect', secret
        socket.get 'secret', (error, secret) ->
          delete sockets[secret] if not error

  socket.on 'mobile', (secret) ->
    if sockets[secret]
      socket.emit 'status', 'pc found!'
      sockets[secret].emit 'status', 'mobile found!'
      socket.on 'message to pc', (message) ->
        if sockets[secret]
          sockets[secret].emit 'message from mobile', message
    else
      socket.emit 'status', 'no connection for secret: ' + secret


server.listen 13000
